<?php

error_reporting(0);
require_once('../../../../wp-config.php');

if (!is_user_logged_in() || !userHasFileRights($_GET['file'])) die("You don't have rights to download the file!");


$file = ABSPATH.'download/'. $_GET['file'];
if (!is_file($file)) die("File dosen't exist!");
$name = rawurldecode($_GET['file']);
$size = filesize($file);
$name = rawurldecode($name);
$known_mime_types = array(
	"pdf" => "application/pdf",
	"exe" => "application/octet-stream",
	"zip" => "application/zip",
	"rar" => "application/rar",
	"doc" => "application/msword",
	"docx"=> "application/msword",
	"xls" => "application/vnd.ms-excel",
	"xlsx"=> "application/vnd.ms-excel",
	"ppt" => "application/vnd.ms-powerpoint",
	"swf" => "application/x-shockwave-flash",
	"mmap"=> "application/mmap",
	"mp3" => "audio/mpeg",
	"wav" => "audio/x-wav",
	"gif" => "image/gif",
	"png" => "image/png",
	"jpeg"=> "image/jpg",
	"jpg" => "image/jpg",
	"txt" => "text/plain",
	"flv" => "video/x-flv",
	"mp4" => "video/mpeg",
	"mpeg"=> "video/mpeg",
	"mpg" => "video/mpeg",
	"mov" => "video/quicktime",
	"avi" => "video/x-msvideo",
	"wmv" => "video/x-ms-wmv",
);
$file_extension = strtolower(substr(strrchr($file,"."),1));
if (array_key_exists($file_extension, $known_mime_types)) $mime_type=$known_mime_types[$file_extension];
else $mime_type="application/force-download";
@ob_end_clean(); //turn off output buffering to decrease cpu usage
// required for IE, otherwise Content-Disposition may be ignored
if(ini_get('zlib.output_compression')) ini_set('zlib.output_compression', 'Off');
header('Content-Type: ' . $mime_type);
header('Content-Disposition: attachment; filename="'.$name.'"');
header("Content-Transfer-Encoding: binary");
header('Accept-Ranges: bytes');
/* The three lines below basically make the download non-cacheable */
header("Cache-control: private");
header('Pragma: private');
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
// multipart-download and download resuming support
if (isset($_SERVER['HTTP_RANGE'])) {
	list($a, $range) = explode("=",$_SERVER['HTTP_RANGE'],2);
	list($range) = explode(",",$range,2);
	list($range, $range_end) = explode("-", $range);
	$range=intval($range);
	if(!$range_end) $range_end = $size-1;
	else $range_end=intval($range_end);
	$new_length = $range_end-$range+1;
	header("HTTP/1.1 206 Partial Content");
	header("Content-Length: $new_length");
	header("Content-Range: bytes $range-$range_end/$size");
}
else {
	$new_length = $size;
	header("Content-Length: ".$size);
}
$chunksize = 1*(1024*1024); //you may want to change this
$bytes_send = 0;
if ($file = fopen($file, 'r')) {
	if(isset($_SERVER['HTTP_RANGE'])) fseek($file, $range);
	while(!feof($file) && (!connection_aborted()) && ($bytes_send<$new_length)) {
		$buffer = fread($file, $chunksize);
		print($buffer); //echo($buffer); // is also possible
		flush();
		$bytes_send += strlen($buffer);
	}
	fclose($file);
}
else die('Error - can not open file.');



function userHasFileRights($fname) {
	global $wpdb, $current_user;
	$res = $wpdb->get_results("SELECT fname FROM {$wpdb->prefix}wpbn_files WHERE fname='$fname' LIMIT 0,1");
	if (!count($res)) return false;
	$tm = time();
	$res = $wpdb->get_results("SELECT {$wpdb->prefix}wpbn_users.prodid FROM {$wpdb->prefix}wpbn_files RIGHT JOIN {$wpdb->prefix}wpbn_users ON {$wpdb->prefix}wpbn_users.prodid={$wpdb->prefix}wpbn_files.productid WHERE (fname='$fname') AND ((expires>$tm) OR (expires=0)) AND ((($tm-tpurchased)/(24*3600))>dripday-1) AND (userid=$current_user->ID) LIMIT 0,1");
	if (count($res)) return true;
	return false;
}


?>