<?php

global $basedir;


if (isset($_GET['s'])) {
	switch ($_GET['s']) {
		case 'calendar': echo Calendar();
	}
}



function SelInterval($fldname='statinterval', $sel='', $width='150', $addstr='', $addopt='') {
	$width .= 'px';
	$html = "
		<select name='$fldname' class='frminput' style='width: $width'$addstr>$addopt".
			sprintf("<option value='0'%s>[custom]</option>", $sel==0?' selected':'').
			sprintf("<option value='1'%s>Today</option>", $sel==1?' selected':'').
			sprintf("<option value='2'%s>Yesterday</option>", $sel==2?' selected':'').
			sprintf("<option value='3'%s>Current Week</option>", $sel==3?' selected':'').
			sprintf("<option value='4'%s>Previous Week</option>", $sel==4?' selected':'').
			sprintf("<option value='5'%s>Current Month</option>", $sel==5?' selected':'').
			sprintf("<option value='6'%s>Previous Month</option>", $sel==6?' selected':'').
			"
			<option value='32'%s>-1 day</option>
			<option value='31'%s>+1 day</option>
			<option value='7'%s>-7 days</option>
			<option value='37'%s>+7 days</option>
			<option value='10'%s>-10 days</option>
			<option value='40'%s>+10 days</option>
			<option value='20'%s>-20 days</option>
			<option value='50'%s>+20 days</option>
			<option value='30'%s>-30 days</option>
			<option value='60'%s>+30 days</option>
		</select>
	";
	return $html;
}


function DateConf() {
	$_GET['tzoffset'] = 0;
	$format = '%d %b %Y';
	if (!isset($_GET['startdate'])) {
		$parts = explode('-', date('Y-d-m'));
		$_GET['startdate'] = mktime(0, 0, 0, $parts[2], $parts[1], $parts[0])-$_GET['tzoffset'];
		$_GET['enddate'] = $_GET['startdate']+24*3600-1;
	}
	if (isset($_GET['changedate'])) {
		if (isset($_GET['gochangedate'])) {
			$_GET['startdate'] = ExtractDate($_GET['startdate']+$_GET['tzoffset']);
			$_GET['enddate'] = ExtractDate($_GET['enddate']+$_GET['tzoffset'])+24*3600-1;
			$_GET['statinterval'] = 0;
		}
		elseif (isset($_GET['statinterval'])) {
			$_GET['statinterval'] = $_GET['statinterval'];
			switch($_GET['statinterval']) {
				case 1: //today
					$parts = explode('-', date('Y-d-m', time()+$_GET['tzoffset']));
					$_GET['startdate'] = mktime(0, 0, 0, $parts[2], $parts[1], $parts[0]);
					$_GET['enddate'] = $_GET['startdate']+24*3600-1;
				break;
				case 2: //yesterday
					$parts = explode('-', date('Y-d-m', time()+$_GET['tzoffset']));
					$_GET['startdate'] = mktime(0, 0, 0, $parts[2], $parts[1]-1, $parts[0]);
					$_GET['enddate'] = mktime(23, 59, 59, $parts[2], $parts[1]-1, $parts[0]);
				break;
				case 3: //current week
				case 4: //previous week
					$tm = time()+$_GET['tzoffset'];
					if ($_GET['statinterval'] == 4) $tm -= 7*24*3600; // previous week
					$day_of_week = date('l', $tm);
					while ($day_of_week != 'Monday') {
						$tm -= 24*3600;
						$day_of_week = date('l', $tm);
					}
					$_GET['startdate'] = ExtractDate($tm);
					$_GET['enddate'] = $_GET['startdate']+(7*24*3600)-1;
				break;
				case 5: //current month
					$parts = explode('-', date('Y-d-m', time()+$_GET['tzoffset']));
					$year = $parts[0];
					$month = $parts[2];
					$_GET['startdate'] = mktime(0, 0, 0, $month, 1, $year);
					$month++;
					if ($month > 12) {
						$month = 1;
						$year++;
					}
					$_GET['enddate'] = mktime(0, 0, 0, $month, 1, $year)-1;
				break;
				case 6: //previous month
					$parts = explode('-', date('Y-d-m', time()+$_GET['tzoffset']));
					$year = $parts[0];
					$month = $parts[2]-1;
					if ($month < 1) {
						$month = 12;
						$year--;
					}
					$_GET['startdate'] = mktime(0, 0, 0, $month, 1, $year);
					$month++;
					if ($month > 12) {
						$month = 1;
						$year++;
					}
					$_GET['enddate'] = mktime(0, 0, 0, $month, 1, $year)-1;
				break;
				case 7:
				case 10:
				case 20:
				case 30:
				case 31:
				case 32:
				case 37:
				case 40:
				case 50:
				case 60:
					$sum_days = $_GET['statinterval'];
					if ($sum_days == 32) $sum_days = -1;
					elseif ($sum_days > 30) $sum_days = $sum_days-30;
					else $sum_days = -$sum_days;
					$startdate = $_GET['startdate'];
					$enddate = $_GET['enddate'];
					$startdate = mktime(date('H', $startdate), date('i', $startdate), date('s', $startdate), date('m', $startdate), date('d', $startdate)+$sum_days, date('Y', $startdate));
					$enddate = mktime(date('H', $enddate), date('i', $enddate), date('s', $enddate), date('m', $enddate), date('d', $enddate)+$sum_days, date('Y', $enddate));
					$_GET['startdate'] = $startdate;
					$_GET['enddate'] = $enddate;
				break;
			}
		}
		$_GET['startdate'] -= $_GET['tzoffset'];
		$_GET['enddate'] -= $_GET['tzoffset'];
	}
	if ($_GET['startdate'] > $_GET['enddate']) {
		$stub = $_GET['startdate'];
		$_GET['startdate'] = $_GET['enddate'];
		$_GET['enddate'] = $stub;
	}
	include_once('plxforms.php');
	$startdate = DatePicker('startdate', $_GET['startdate']+$_GET['tzoffset'], 100, 1, 'm/d/Y');
	$enddate = DatePicker('enddate', $_GET['enddate']+$_GET['tzoffset'], 100, 1, 'm/d/Y');
	if (!isset($_GET['statinterval'])) $_GET['statinterval'] = 0;
	$selinterval = SelInterval('statinterval', $_GET['statinterval'], 110, '');
	$html = "
		<input type='hidden' name='changedate' value='1' />
		<table cellspacing='7' style='margin: 15px 0 15px 0;'>
			<tr>
				<th><strong>Period:</strong></th>
				<td>$selinterval</td><td>From:</td><td>$startdate</td><td>&nbsp;&nbsp;&nbsp;&nbsp;To:</td><td>$enddate</td>
			</tr>
		</table>
	";
	return $html;
}



function DatePicker($fldname, $val=0, $width=80, $zindex=1) {
	if ($val == -1) {
		$show = date('m/d/Y');
		$value = time();
	}
	elseif ($val > 0) {
		$val = mktime(0, 0, 0, date('m', $val), date('d', $val), date('Y', $val));
		$show = date('m/d/Y', $val);
		$value = $val;
	}
	else {
		$show = '';
		$value = '';
	}
	$width = $width.'px';
	$left = $width;
	$dw = ($width+25).'px';
	$html = "
		<style>
			.datefld {
				color:#000000;
				background:#F7F7F7;
				font-family: Arial;
				font-size: 8pt;
				border: 1px solid navy;
				padding-left: 3px;
				border-top: 1px solid black;
				border-left: 1px solid black;
				border-right: 1px solid #AAAAAA;
				border-bottom: 1px solid #AAAAAA;
			}
			div.calcontainer {
				width: 160px;
				height: 160px;
			}
		</style>
		<div style='position: relative; float: left; width: $dw; z-index: $zindex'>
			<input type='hidden' name='$fldname' id='$fldname' value='$value' />
			<input type='text' id='show_$fldname' class='datefld' style='width: $width' value='$show' readonly='readonly' /> <a href=\"javascript: SetFrSrc('".FASTMEM_URL."lib/', '$fldname'); ShowHideLayer('layer_$fldname');\"><img src='".FASTMEM_URL."img/calendar.gif' width='16' height='16' title='choose date' align='textTop' alt='choose date' style='border: 0;' /></a>
			<div id='layer_$fldname' class='calcontainer' style='position: absolute; left: $left; top: 20px; display: none;'>
				<iframe name='if_$fldname' id='if_$fldname' style='width: 100%; height: 100%;' frameborder=0 scrolling='no'></iframe>
			</div>
		</div>
	";
	return $html;
}



function Calendar() {
	$html = "
		<html>
		<head>
			<meta http-equiv='Content-Type' content='text/html; charset=windows-1251' />
			<script src='../js/plxforms.js' type='text/javascript' language='javascript'></script>
			<link href='../css/plxforms.css' rel='stylesheet' type='text/css'>
		</head>
		<body style='margin: 0; padding: 0;'>
	";
	$seldate = $_GET['sel'];
	if ($seldate <= 0) $seldate = time();
	$fldname = $_GET['fld'];
	if (isset($_GET['m']) && isset($_GET['y'])) $curdate = getdate(mktime(0, 0, 0, $_GET['m'], 1, $_GET['y']));
	else $curdate = getdate($seldate);
	$cal_year = $curdate['year'];
	$cal_month = $curdate['mon'];
	$months = array('January', 'Februray', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December');
	$selmonth = "<select class='calcombo' name='selm' id='selm' onchange=\"document.location='plxforms.php?s=calendar&fld=$fldname&sel=$seldate&m='+this.value+'&y='+document.getElementById('sely').value;\">";
	for ($i=1; $i<13; $i++) $selmonth .= sprintf("<option value='$i'%s>%s</option>", $curdate['mon']==$i?' selected':'', $months[$i-1]);
	$selmonth .= '</select>';
	$sely = "<select class='calcombo' name='sely' id='sely' onchange=\"document.location='plxforms.php?s=calendar&fld=$fldname&sel=$seldate&m='+document.getElementById('selm').value+'&y='+this.value;\">";
	for ($i=2000; $i<2021; $i++) $sely .= sprintf("<option value='$i'%s>%s</option>", $curdate['year']==$i?' selected':'', $i);
	$sely .= '</select>';
	$pmyear = $cal_year;
	$prevmonth = $cal_month-1;
	if ($prevmonth < 1) {
		$prevmonth = 12;
		$pmyear--;
	}
	$nmyear = $cal_year;
	$nextmonth = $cal_month+1;
	if ($nextmonth > 12) {
		$nextmonth = 1;
		$nmyear++;
	}
	$pyear = $cal_year-1;
	$nyear = $cal_year+1;
	$html .= "
		<div class='calbody' style='width: 100%; height: 100%; margin: 0; padding: 0;'>
			<table style='width: 100%; height: 100%; margin: 0;' cellspacing='0' cellpadding='1'>
			<tr><td colspan='7' class='caltitle'>$selmonth&nbsp;$sely</td></tr>
			<tr><td class='calweekdays'>Mo</td><td class='calweekdays'>Tu</td><td class='calweekdays'>We</td><td class='calweekdays'>Th</td><td class='calweekdays'>Fr</td><td class='calweekdays'>Sa</td><td class='calweekdays'>Su</td></tr>
			<tr>
	";
	$colcounter = 1;
	for ($day=1; $day<=31; $day++) {
		$curdate = mktime(0, 0, 0, $cal_month, $day, $cal_year);
		if ($day == 1) {
			$dayweek = getdate($curdate);
			$dayweek = $dayweek['wday'];
			if ($dayweek == 0) $dayweek = 7;
			$dayweek--;
			if ($dayweek > 0) $html .= "<td colspan='$dayweek'>&nbsp;</td>";
			$colcounter = $dayweek+1;
		}
		if (!checkdate($cal_month, $day, $cal_year)) break;
		$class = $curdate==$seldate?'calselected':'dayno';
		$show = date('m/d/Y', $curdate);
		$html .= "<td class='$class' onclick=\"SetDay('$fldname', '$curdate', '$show');\" onmouseover=\"ChangeStyle(this, 'dayyes');\" onmouseout=\"ChangeStyle(this, '$class');\">$day</td>";
		$colcounter++;
		if ($colcounter > 7) {
			$html .= "</tr><tr>";
			$colcounter = 1;
		}
	}
	if (($colcounter < 8) && ($colcounter != 1)) {
		$colcounter = 8 - $colcounter;
		$html .= "<td colspan='$colcounter'>&nbsp;</td>";
	}
	$html .= "
		</tr></table></div>
		</body></html>
	";
	return $html;
}



function NumField($fldname, $val=0, $from=1, $to=0, $step=1, $width=30) {
	$dw = ($width+15).'px';
	$width = $width.'px';
	$val = round($val);
	$html = "
		<div style='position: relative; float: left; width: $dw; margin: 0; padding: 0; text-align: left;'>
			<input type='text' name='$fldname' id='$fldname' class='numfld' style='width: $width' value='$val' onkeypress=\"return numeralsOnly(event)\" onchange=\"CheckNumLimit('$fldname', $from, $to);\" />
			<div style='position: absolute; left: $width; top: 1px'><a href='javascript:'><img src='".FASTMEM_URL."img/numup.gif' width='12' height='8' style='border: 0;' title='num up' alt='num up' onmousedown=\"StartNumUp('$fldname', $to, $step);\" onmouseup=\"EndTimer();\" /></a></div>
			<div style='position: absolute; left: $width; top: 9px'><img src='".FASTMEM_URL."img/numbg.gif' width='12' height='2' style='border: 0;' title='num bg' alt='num bg'  /></div>
			<div style='position: absolute; left: $width; top: 11px'><a href='javascript:'><img src='".FASTMEM_URL."img/numdown.gif' width='12' height='8' style='border: 0;' title='num down' alt='num down' onmousedown=\"StartNumDown('$fldname', $from, $step);\" onmouseup=\"EndTimer();\" /></a></div>
		</div>
	";
	return $html;
}



function CheckBoxesGroup($cbarray, $fldname, $prefix='cb_', $width=200, $zindex=1) {
	$cb = '';
	foreach ($cbarray as $k=>$v) {
		$checked = '';
		if (substr($k, 0, 1) == '*') {
			$checked = ' checked';
			$k = substr($k, 1);
		}
		$cb .= "<div style='float: left'><input type='checkbox' name='$prefix$k' value='$k'$checked /></div> <div style='float: left'>$v</div><div style='clear:both;'></div>";
	}
	$width .= 'px';
	$html = "
		<div style='position: relative; float: left; width: 16px;'>
			<input type='hidden' name='$fldname' id='$fldname' value='' />
			<a href='javascript:'><img src='".FASTMEM_URL."img/cbbut.gif' width='16' height='16' title='check' alt='check' style='border: 0;' onclick=\"ShowHideLayer('layer_$fldname');\" /></a>
			<div id='layer_$fldname' class='cbcontainer' style='position: absolute; left: 17px; top: 1px; width: $width; display: none; z-index: $zindex'>
				$cb
				<div style='text-align: left; margin-bottom: 8px; margin-top: 4px;'>&nbsp;<input type='button' class='cbokbut' value=' ok ' onclick=\"ShowHideLayer('layer_$fldname');\" /></div>
			</div>
		</div>
	";
	return $html;
}


function ExtractDate($tm) {
	return mktime (0, 0, 0, date('m', $tm), date('d', $tm), date('Y', $tm));
}


?>