<?php

error_reporting(0);
require_once('../../../../wp-config.php');
include_once('open-flash-chart.php');

$g = new graph();

if (!isset($_GET['sub'])) $_GET['sub'] = 'hits';

if ($_GET['sub'] == 'hits') {
	$tm = time()-24*3600;
	$arrhits = array();
	$arruhits = array();
	$arrsales = array();
	$arramounts = array();
	$arrprofits = array();
	$maxy = 0; $maxy2 = 0;

	$fromtime = $_GET['fromtime'];
	$totime = $_GET['totime'];
	$addq = (isset($_GET['prodid']) && $_GET['prodid'])?" AND (prodid='$_GET[prodid]')":'';

	if ((($totime-$fromtime)/3600) < 30) {
		$isday = 1;
		$addnum = 3600;
		$g->set_x_legend('Hours', 12, '#333333');
	}
	else {
		$isday = 0;
		$addnum = 24*3600;
		$g->set_x_legend('Dates', 12, '#333333');
	}


	$ft = $fromtime;
	while (1) {
		$tt = $ft+$addnum;
		$res = $wpdb->get_results("SELECT COUNT(userip) as hits, COUNT(DISTINCT userip) as uhits FROM {$wpdb->prefix}wpbn_hits WHERE (htime>$ft) AND (htime<$tt)$addq");
		if (count($res)) {
			$res = $res[0];
			if ($res->hits > $maxy) $maxy = $res->hits;
			$arrhits[] = $res->hits;
			$arruhits[] = $res->uhits;
		}
		else {
			$arrhits[] = 0;
			$arruhits[] = 0;
		}
		$res = $wpdb->get_results("SELECT COUNT(madesale) as sales FROM {$wpdb->prefix}wpbn_hits WHERE madesale AND (htime>$ft) AND (htime<$tt)$addq");
		if (count($res)) {
			$res = $res[0];
			$arrsales[] = $res->sales;
		}
		else $arrsales[] = 0;
		$res = $wpdb->get_results("SELECT SUM(amount) as amount, SUM(amount-(amount*affcomm/100)) as profit FROM {$wpdb->prefix}wpbn_transactions WHERE (ttransaction>$ft) AND (ttransaction<$tt)$addq");
		if (count($res)) {
			$res = $res[0];
			if ($res->amount > $maxy2) $maxy2 = $res->amount;
			$arrprofits[] = round($res->profit, 2);
			$arramounts[] = round($res->amount, 2);
		}
		else {
			$arrprofits[] = 0;
			$arramounts[] = 0;
		}
		$labels[] = $isday?date('m/d/Y h:i a', $ft):date('m/d/Y', $ft);
		$ft += $addnum;
		if ($ft > $totime) break;
	}

	$t = (isset($_GET['prodid']) && $_GET['prodid'])?' - '.$wpdb->get_var("SELECT title FROM {$wpdb->prefix}wpbn_products WHERE id='$_GET[prodid]'"):'';
	$g->title('Hits & Sales Stats'.$t, '{font-size: 18px; color: #333333}');
	$g->set_bg_colour('#FFFFFF');
	$g->set_inner_background('#f1f1f3');
	$g->x_axis_colour('#dbdbdd', '#dbdbdd');
	$g->y_axis_colour('#dbdbdd', '#dbdbdd');
	$g->y_right_axis_colour('#dbdbdd');
	$g->set_y_legend('Hits / Sales', 12, '#333333');
	$g->set_y_right_legend('Revenue / Profit (USD)', 12 , '#333333');
	$g->set_data($arrhits);
	$g->area_hollow(1, 2, 100, '#9a1d21', 'Hits', 14);
	$g->set_data($arruhits);
	$g->area_hollow(1, 2, 100, '#ecb630', 'Unique Hits', 14);
	$g->set_data($arrsales);
	$g->area_hollow(1, 2, 100, '#33FF99', 'Sales', 14);
	$g->set_data($arramounts);
	$g->line_hollow(2, 2, '#6600CC', 'Revenue', 14);
	$g->attach_to_y_right_axis(4);
	$g->set_data($arrprofits);
	$g->line_hollow(2, 2, '#339933', 'Net Profit', 14);
	$g->attach_to_y_right_axis(5);
	if (!$maxy) $maxy = 1;
	if (!$maxy2) $maxy2 = 1;
	$g->set_y_max($maxy);
	$g->set_y_right_max($maxy2);
	$g->set_x_labels($labels);
	$g->set_x_label_style(10, '#000000', 2, 1);
	die($g->render());
}






if ($_GET['sub'] == 'coupon') {
	$tm = time()-24*3600;
	$arrhits = array();
	$arruhits = array();
	$arrsales = array();
	$maxy = 0; $maxy2 = 0;

	$fromtime = $_GET['fromtime'];
	$totime = $_GET['totime'];
	$addq = " AND (coupon='$_GET[code]')";
	if ((($totime-$fromtime)/3600) < 30) {
		$isday = 1;
		$addnum = 3600;
		$g->set_x_legend('Hours', 12, '#333333');
	}
	else {
		$isday = 0;
		$addnum = 24*3600;
		$g->set_x_legend('Dates', 12, '#333333');
	}

	$ft = $fromtime;
	while (1) {
		$tt = $ft+$addnum;
		$res = $wpdb->get_results("SELECT COUNT(userip) as hits, COUNT(DISTINCT userip) as uhits FROM {$wpdb->prefix}wpbn_hits WHERE (htime>$ft) AND (htime<$tt)$addq");
		if (count($res)) {
			$res = $res[0];
			if ($res->hits > $maxy) $maxy = $res->hits;
			$arrhits[] = $res->hits;
			$arruhits[] = $res->uhits;
		}
		else {
			$arrhits[] = 0;
			$arruhits[] = 0;
		}
		$res = $wpdb->get_results("SELECT COUNT(madesale) as sales FROM {$wpdb->prefix}wpbn_hits WHERE madesale AND (htime>$ft) AND (htime<$tt)$addq");
		if (count($res)) {
			$res = $res[0];
			$arrsales[] = $res->sales;
		}
		else $arrsales[] = 0;
		$res = $wpdb->get_results("SELECT SUM(amount) as amount, SUM(amount-(amount*affcomm/100)) as profit FROM {$wpdb->prefix}wpbn_transactions WHERE (ttransaction>$ft) AND (ttransaction<$tt)$addq");
		if (count($res)) {
			$res = $res[0];
			if ($res->amount > $maxy2) $maxy2 = $res->amount;
			$arrprofits[] = round($res->profit, 2);
			$arramounts[] = round($res->amount, 2);
		}
		else {
			$arrprofits[] = 0;
			$arramounts[] = 0;
		}
		$labels[] = $isday?date('m/d/Y h:i a', $ft):date('m/d/Y', $ft);
		$ft += $addnum;
		if ($ft > $totime) break;
	}
	$g->title('Coupon Stats: '.$_GET['code'], '{font-size: 18px; color: #333333}');
	$g->set_bg_colour('#FFFFFF');
	$g->set_inner_background('#f1f1f3');
	$g->x_axis_colour('#dbdbdd', '#dbdbdd');
	$g->y_axis_colour('#dbdbdd', '#dbdbdd');
	$g->y_right_axis_colour('#dbdbdd');
	$g->set_y_legend('Hits / Sales', 12, '#333333');
	$g->set_y_right_legend('Revenue / Profit (USD)', 12 , '#333333');
	$g->set_data($arrhits);
	$g->area_hollow(1, 2, 100, '#9a1d21', 'Hits', 14);
	$g->set_data($arruhits);
	$g->area_hollow(1, 2, 100, '#ecb630', 'Unique Hits', 14);
	$g->set_data($arrsales);
	$g->area_hollow(1, 2, 100, '#33FF99', 'Sales', 14);
	$g->set_data($arramounts);
	$g->line_hollow(2, 2, '#6600CC', 'Revenue', 14);
	$g->attach_to_y_right_axis(4);
	$g->set_data($arrprofits);
	$g->line_hollow(2, 2, '#339933', 'Net Profit', 14);
	$g->attach_to_y_right_axis(5);
	if (!$maxy) $maxy = 1;
	if (!$maxy2) $maxy2 = 1;
	$g->set_y_max($maxy);
	$g->set_y_right_max($maxy2);
	$g->set_x_labels($labels);
	$g->set_x_label_style(10, '#000000', 2, 1);
	die($g->render());
}


?>