<?php

require_once('../../../../wp-config.php');

//get the settings
$lastcron = get_settings('fastmem_lastcron');
$cronsent = get_settings('fastmem_cronsent');
$res = $wpdb->get_results("SELECT * FROM {$wpdb->prefix}wpbn_settings WHERE 1");
$res = $res[0];
$sendername = $res->sendername;
$senderemail = $res->senderemail;
$mailer = $res->mailer;
if (!$mailer) $mailer = 1;
$mailerconf = unserialize($res->mailerconfig);
$maxmsgs = $mailerconf['maxmsgs'];
$from = array($senderemail=>$sendername);

if ($mailer == 1) {
	if ((time()-$lastcron) > 3600) {
		update_option('fastmem_lastcron', time());
		update_option('fastmem_cronsent', 0);
	}
	elseif ($cronsent >= $maxmsgs) die();
}

$numsent = 0;
//send autoresponder messages or add them to the que if throttling is selected
$arsent = get_settings('fastmem_arsent');
if (!$arsent) $arsent = 0;
$arnow = date('Ymd');
if ($arsent < $arnow) {
	update_option('fastmem_arsent', $arnow);
	$data = $wpdb->get_results("SELECT * FROM {$wpdb->prefix}wpbn_autoresponders WHERE active=1");
	foreach ($data as $k=>$obj) {
		$prods = $obj->products;
		if (substr($prods, 0, 1) == ';') $prods = substr($prods, 1, strlen($prods)-1);
		if (substr($prods, -1) == ';') $prods = substr($prods, 0, strlen($prods)-1);
		$prods = str_replace(';', ',', $prods);
		$q = "prodid in ($prods)";
		if (!$prods) $q = '1';
		$nonprods = $obj->products;
		if (substr($nonprods, 0, 1) == ';') $nonprods = substr($nonprods, 1, strlen($nonprods)-1);
		if (substr($nonprods, -1) == ';') $nonprods = substr($nonprods, 0, strlen($nonprods)-1);
		$nonprods = str_replace(';', ',', $nonprods);
		if (!$nonprods) $nonprods = '';
		$data2 = $wpdb->get_results("SELECT * FROM {$wpdb->prefix}wpbn_armessages WHERE arid=$obj->id");
		foreach ($data2 as $k2=>$obj2) {
			if ($mailer == 3) $arr_recipients = array(); // send grid
			$data3 = $wpdb->get_results("SELECT * FROM {$wpdb->prefix}wpbn_users WHERE $q;");
			$customized = 0;
			if (strpos(' '.$obj2->subject, '[first_name]') || strpos(' '.$obj2->subject, '[last_name]') || strpos(' '.$obj2->subject, '[login]')) $customized = 1;
			if (!$customized) if (strpos(' '.$obj2->message, '[first_name]') || strpos(' '.$obj2->message, '[last_name]') || strpos(' '.$obj2->message, '[login]')) $customized = 1;
			foreach ($data3 as $k3=>$obj3) {
				if ($nonprods) $stub = $wpdb->get_var("SELECT id FROM {$wpdb->prefix}wpbn_products WHERE (userid=$obj3->userid) AND (prodid in ($nonprods))");
				else $stub = 0;
				if ($stub) continue;
				$uinfo = $wpdb->get_results("SELECT user_email, user_login, display_name FROM {$wpdb->prefix}users WHERE ID='$obj3->userid'");
				$uinfo = $uinfo[0];
				if (!trim($uinfo->user_email)) continue;
				$fname = get_usermeta($obj3->userid, 'first_name');
				$lname = get_usermeta($obj3->userid, 'last_name');
				$subj = $obj2->subject;
				$mailmsg = $obj2->message;
				if ($customized) {
					$subj = str_replace('[first_name]', $fname, $subj);
					$subj = str_replace('[last_name]', $lname, $subj);
					$subj = str_replace('[login]', $uinfo->user_login, $subj);
					$mailmsg = str_replace('[first_name]', $fname, $mailmsg);
					$mailmsg = str_replace('[last_name]', $lname, $mailmsg);
					$mailmsg = str_replace('[login]', $uinfo->user_login, $mailmsg);
				}
				if ($mailer == 1) $wpdb->query("INSERT INTO {$wpdb->prefix}wpbn_mailque (email, subject, message) VALUES ('$uinfo->user_email', '$subj', '$mailmsg');");
				elseif ($mailer == 2) fastmemSendMail($uinfo->user_email, $subj, $mailmsg, $sendername, $senderemail);
				elseif ($customized) fastmemSendGrid(array($uinfo->user_email=>$uinfo->display_name), $subj, $mailmsg, $from);
				else $arr_recipients[$uinfo->user_email] = $uinfo->display_name;
			}
			if (($mailer == 3) && !$customized) fastmemSendGrid($arr_recipients, $subj, $mailmsg, $from);
		}
	}
}


//process the mail que if throttling is selected
if ($mailer == 1) {
	$data = $wpdb->get_results("SELECT * FROM {$wpdb->prefix}wpbn_mailque WHERE 1 ORDER BY id LIMIT 0, $maxmsgs");
	foreach ($data as $k=>$obj) {
		fastmemSendMail($obj->email, $obj->subject, $obj->message, $sendername, $senderemail);
	}
	$wpdb->query("DELETE FROM {$wpdb->prefix}wpbn_mailque WHERE 1 ORDER BY id LIMIT $maxmsgs");
}

if ($mailer == 1) update_option('fastmem_cronsent', $cronsent+$numsent);
echo 'cron completed.';



function fastmemSendMail($tomail, $subj, $mailmsg, $from='', $frommail='') {
	global $numsent;
	$numsent++;
	include_once('phpmailer.php');
	$altbody = str_replace('<br />', "\n", $mailmsg);
	$altbody = str_replace('&nbsp;', ' ', $altbody);
	$altbody = trim(strip_tags($altbody));
	//if (!$from) $from = GetConfig('sitename');
	//if (!$frommail) $frommail = GetConfig('contactemail');
	$mail = new phpmailer();
	$mail->From = $frommail;
	$mail->FromName = $from;
	$mail->AddAddress($tomail);
	$mail->Subject = $subj;
	$mail->IsHTML(true);
	$mail->Body = $mailmsg;
	$mail->AltBody = $altbody;
	$mail->Send();
}


function fastmemSendGrid($toList, $subject, $html, $from) {
	global $mailerconf;
	$url = 'http://sendgrid.com/';
	$user = $mailerconf['sendgridu'];
	$pass = $mailerconf['sendgridp'];
	$text = str_replace('<br />', "\n", $html);
	$text = strip_tags($text);
	$params = array(
		'api_user'  => $user,
		'api_key'   => $pass,
		'x-smtpapi' => json_encode(array('to' => $toList)),
		'subject'   => $subject,
		'html'      => $html,
		'text'      => $text,
		'from'      => json_encode($from)
	  );
	$request =  $url.'api/mail.send.json';
	$session = curl_init($request);
	curl_setopt ($session, CURLOPT_POST, true);
	curl_setopt ($session, CURLOPT_POSTFIELDS, $params);
	curl_setopt($session, CURLOPT_HEADER, false);
	curl_setopt($session, CURLOPT_RETURNTRANSFER, true);
	$response = curl_exec($session);
	curl_close($session);
	//print_r($response);
}


?>