<?php

class fastmemWidget extends WP_Widget {

	function fastmemWidget() {
		parent::__construct(false, 'Fast Member Widget', array(), array('width'=>'410px', 'height'=>'400px'));
	}

	function widget($args, $instance) {
		global $before_widget, $before_title, $after_title, $after_widget;
		echo $before_widget;
		echo $before_title . $after_title;
		echo do_shortcode($instance['fastmemshortcodes']);
		echo $after_widget;
	}

	function update($new_instance, $old_instance) {
		$instance = wp_parse_args($new_instance, $old_instance);
		return $instance;
	}

	function form($instance) {
		$fld = $this->get_field_id('fastmemshortcodes');
		$fldn = $this->get_field_name('fastmemshortcodes');
		if (!isset($instance['fastmemshortcodes'])) $instance['fastmemshortcodes'] = '';
		echo "
			<div style='width: 410px;'>
				Content / shortcodes:<br />
				<textarea id='$fld' name='$fldn' style='width: 400px;' rows='5'>$instance[fastmemshortcodes]</textarea>
				<iframe src='".FASTMEM_URL."/lib/insbut.php?s=but&instance=$fld' style='width: 400px; height: 350px;'></iframe>
			</div>
		";
	}
}

function fastmemWidget_reg() {
	register_widget('fastmemWidget');
}

add_action('widgets_init', 'fastmemWidget_reg');

?>